from __future__ import annotations

from collections.abc import Mapping
from typing import TYPE_CHECKING, Any, TypeVar

from attrs import define as _attrs_define
from attrs import field as _attrs_field

from ..types import UNSET, Unset

if TYPE_CHECKING:
    from ..models.table_cell import TableCell


T = TypeVar("T", bound="TableRow")


@_attrs_define
class TableRow:
    """
    Attributes:
        x (float | Unset):
        y (float | Unset):
        width (float | Unset):
        height (float | Unset):
        page (float | Unset):
        cells (list[TableCell] | Unset):
        class_ (str | Unset):
        class_confidence (float | Unset):
    """

    x: float | Unset = UNSET
    y: float | Unset = UNSET
    width: float | Unset = UNSET
    height: float | Unset = UNSET
    page: float | Unset = UNSET
    cells: list[TableCell] | Unset = UNSET
    class_: str | Unset = UNSET
    class_confidence: float | Unset = UNSET
    additional_properties: dict[str, Any] = _attrs_field(init=False, factory=dict)

    def to_dict(self) -> dict[str, Any]:
        x = self.x

        y = self.y

        width = self.width

        height = self.height

        page = self.page

        cells: list[dict[str, Any]] | Unset = UNSET
        if not isinstance(self.cells, Unset):
            cells = []
            for cells_item_data in self.cells:
                cells_item = cells_item_data.to_dict()
                cells.append(cells_item)

        class_ = self.class_

        class_confidence = self.class_confidence

        field_dict: dict[str, Any] = {}
        field_dict.update(self.additional_properties)
        field_dict.update({})
        if x is not UNSET:
            field_dict["x"] = x
        if y is not UNSET:
            field_dict["y"] = y
        if width is not UNSET:
            field_dict["width"] = width
        if height is not UNSET:
            field_dict["height"] = height
        if page is not UNSET:
            field_dict["page"] = page
        if cells is not UNSET:
            field_dict["cells"] = cells
        if class_ is not UNSET:
            field_dict["class"] = class_
        if class_confidence is not UNSET:
            field_dict["classConfidence"] = class_confidence

        return field_dict

    @classmethod
    def from_dict(cls: type[T], src_dict: Mapping[str, Any]) -> T:
        from ..models.table_cell import TableCell

        d = dict(src_dict)
        x = d.pop("x", UNSET)

        y = d.pop("y", UNSET)

        width = d.pop("width", UNSET)

        height = d.pop("height", UNSET)

        page = d.pop("page", UNSET)

        _cells = d.pop("cells", UNSET)
        cells: list[TableCell] | Unset = UNSET
        if _cells is not UNSET:
            cells = []
            for cells_item_data in _cells:
                cells_item = TableCell.from_dict(cells_item_data)

                cells.append(cells_item)

        class_ = d.pop("class", UNSET)

        class_confidence = d.pop("classConfidence", UNSET)

        table_row = cls(
            x=x,
            y=y,
            width=width,
            height=height,
            page=page,
            cells=cells,
            class_=class_,
            class_confidence=class_confidence,
        )

        table_row.additional_properties = d
        return table_row

    @property
    def additional_keys(self) -> list[str]:
        return list(self.additional_properties.keys())

    def __getitem__(self, key: str) -> Any:
        return self.additional_properties[key]

    def __setitem__(self, key: str, value: Any) -> None:
        self.additional_properties[key] = value

    def __delitem__(self, key: str) -> None:
        del self.additional_properties[key]

    def __contains__(self, key: str) -> bool:
        return key in self.additional_properties
